package com.yanzhu.jh.trouble.service;

import java.util.List;
import java.util.Map;

import com.yanzhu.jh.trouble.domain.SmzSspAuditinfo;
import com.yanzhu.jh.trouble.domain.SmzSspProblemmodify;
import com.yanzhu.jh.trouble.domain.where.SmzSspProblemmodifyWhere;

/**
 * 质量整改Service接口
 * 
 * @author JiangYuQi
 * @date 2023-07-28
 */
public interface ISmzSspProblemmodifyService 
{
    /**
     * 查询质量整改
     * 
     * @param id 质量整改主键
     * @return 质量整改
     */
    public SmzSspProblemmodify selectSmzSspProblemmodifyById(Long id);

    /**
     * 查询质量整改详情
     *
     * @param id 质量整改主键
     * @return 质量整改
     */
    public SmzSspProblemmodify selectSmzSspProblemmodifyInfoById(Long id);

    /**
     * 查询质量整改列表
     * 
     * @param smzSspProblemmodify 质量整改
     * @return 质量整改集合
     */
    public List<SmzSspProblemmodify> selectSmzSspProblemmodifyList(SmzSspProblemmodify smzSspProblemmodify);

    /**
     * 查询质量整改列表
     *
     * @param smzSspProblemmodify 质量整改
     * @return 质量整改集合
     */
    public List<SmzSspProblemmodify> selectWechatSmzSspProblemmodifyList(SmzSspProblemmodify smzSspProblemmodify);

    /**
     * 根据状态分组统计数量
     * @param smzSspProblemmodify 查询条件
     * @return List<Map<String, Integer>>
     */
    public Map<String, Object> findProblemmodifyGroupByCheckState(SmzSspProblemmodify smzSspProblemmodify);

    /**
     * 新增质量整改
     * 
     * @param smzSspProblemmodify 质量整改
     * @return 结果
     */
    public int insertSmzSspProblemmodify(SmzSspProblemmodify smzSspProblemmodify);

    /**
     * 修改质量整改
     * 
     * @param smzSspProblemmodify 质量整改
     * @return 结果
     */
    public int updateSmzSspProblemmodify(SmzSspProblemmodify smzSspProblemmodify);

    /**
     * 批量删除质量整改
     * 
     * @param ids 需要删除的质量整改主键集合
     * @return 结果
     */
    public int deleteSmzSspProblemmodifyByIds(Long[] ids);

    /**
     * 删除质量整改信息
     * 
     * @param id 质量整改主键
     * @return 结果
     */
    public int deleteSmzSspProblemmodifyById(Long id);

    /**
     * 分类汇总(按分类)
     * @param deptId 部门编号 0为全部
     * @param roleType 0 为全部 //3集团//4子公司//5监理单位//6总包//7分包
     * @param infoType 信息类型（0安全，1质量）
     * @return
     */
    public List<SmzSspProblemmodify> selectSummary(SmzSspProblemmodifyWhere where);

    /**
     * 分类汇总(按项目)
     * @param deptId 部门编号 0为全部
     * @param roleType 0 为全部 //3集团//4子公司//5监理单位//6总包//7分包
     * @param infoType 信息类型（0安全，1质量）
     * @return
     */
    public List<SmzSspProblemmodify> selectSummaryByProject(SmzSspProblemmodifyWhere where);

    public List<SmzSspProblemmodify> countByDate(SmzSspProblemmodifyWhere where);

    public List<SmzSspProblemmodify> countByDateRange(SmzSspProblemmodifyWhere where);

    public List<SmzSspProblemmodify> groupByInfotypeCheckState(SmzSspProblemmodifyWhere where);

    public Long countTimeout(SmzSspProblemmodifyWhere where);
}
